#SingleInstance Force
#IfWinActive ahk_exe SDLTradosStudio.exe

; ------------------------
; Lore Ipsum Generator
; fills target segment with Lore ipsum text
; ------------------------
^!c::
ClipboardStore := ClipboardAll ;Store clipboard content, so that it can be used after the script termninated

Clipboard  := CopySourceSegmentText()
SourceLength := StrLen(Clipboard)
LastChar := SubStr(Clipboard, SourceLength, 1)

; Change TextIncrease as required to simulate appropriate target text volume
TextIncrease := 1.3
SourceLength := Round(SourceLength * TextIncrease)

if(SourceLength > 5)
{
	GeneratedText := LoreIpsum(SourceLength)
	Sleep, 50
	SendInput, %GeneratedText%%LastChar%
	Sleep, 50
	ChangeSegmentStatus("r") ;change the status of the segment. Values "r"=Translation rejected, "s"=Sign-off rejected, "d"=Draft, "n"=Not translated
	Sleep, 50
	SendInput {control down}l{control up} ;lock the segment
}
else
{
	Exit
}

Clipboard := ClipboardStore
return

LoreIpsum(_length)
{
	_LoreIpsumFullText := "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Curabitur pretium tincidunt lacus. Nulla gravida orci a odio. Nullam varius, turpis et commodo pharetra, est eros bibendum elit, nec luctus magna felis sollicitudin mauris. Integer in mauris eu nibh euismod gravida. Duis ac tellus et risus vulputate vehicula. Donec lobortis risus a elit. Etiam tempor. Ut ullamcorper, ligula eu tempor congue, eros est euismod turpis, id tincidunt sapien risus a quam. Maecenas fermentum consequat mi. Donec fermentum. Pellentesque malesuada nulla a mi. Duis sapien sem, aliquet nec, commodo eget, consequat quis, neque. Aliquam faucibus, elit ut dictum aliquet, felis nisl adipiscing sapien, sed malesuada diam lacus eget erat. Cras mollis scelerisque nunc. Nullam arcu. Aliquam consequat. Curabitur augue lorem, dapibus quis, laoreet et, pretium ac, nisi. Aenean magna nisl, mollis quis, molestie eu, feugiat in, orci. In hac habitasse platea dictumst."

	_LoreIpsumFragment := SubStr(_LoreIpsumFullText, 1, _length)

	return _LoreIpsumFragment
}


ChangeSegmentStatus(_Status)
{
	Sleep, 50
	SendInput {Alt}
	Sleep, 50
	SendInput H
	Sleep, 50
	SendInput U
	Sleep, 50
	SendInput %_Status%
}
; ------------------------
; Copy source text segment, written by Jess Prieto
; ------------------------
CopySourceSegmentText()
{
	CheckKey_CONTROL_Up()
	CheckKey_SHIFT_Up()

	; Select all in TARGET
	SelectAll()
	; Copy all (text + tags) from TARGET
	Copy()
	Target := ClipboardAll    

	; Copy from SOURCE to TARGET
	SendInput !{Insert}
	; Select all + Copy text
	SelectAll()
	Copy()
	Source := Clipboard

	; Restore TARGET
	length := StrLen(Target)
	if (length)
	{
		Undo()
		SendInput {Right}
	}
	; Delete the following 2 lines (else + SendInput)
	; if you want to insert SOURCE > TARGET
	; whenever TARGET is empty
	else
		SendInput !{Delete}  

	; Copy SOURCE text to Clipboard
	return Source
}

Copy()
{
	clipboard = ; Empty Clipboard
	SendInput {control down}c{control up}
	ClipWait, 0
}

Paste()
{
	SendInput {control down}v{control up}
	Sleep, 200
}

SelectAll()
{
	SendInput {ctrl down}a{ctrl up}
}

Undo()
{
	SendInput {ctrl down}z{ctrl up}
}

; Check if CONTROL key is UP
CheckKey_CONTROL_Up()
{
	while GetKeyState("Control", P)
		Sleep, 20
}

; Check if SHIFT key is UP
CheckKey_SHIFT_Up()
{
	while GetKeyState("Shift", P)
		Sleep, 20
}